/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.tool;

import android.content.ContentProviderOperation;
import android.content.ContentProviderResult;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.OperationApplicationException;
import android.database.Cursor;
import android.os.RemoteException;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.CallNote;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.ui.NotesListAdapter.AppWidgetAttribute;

import java.util.ArrayList;
import java.util.HashSet;


public class DataUtils {
    public static final String TAG = "DataUtils";
/**
 * 批量删除便签
 * @param resolver 内容解析器
 * @param ids 待删除便签的ID集合
 * @return 如果删除成功删除所有指定的便签，则返回true；否则返回false
 */
public static boolean batchDeleteNotes(ContentResolver resolver, HashSet<Long> ids) {
    if (ids == null) {
        // 如果ids为null，记录调试信息并返回true
        Log.d(TAG, "the ids is null");
        return true;
    }
    if (ids.size() == 0) {
        // 如果ids集合为空，记录调试信息并返回true
        Log.d(TAG, "no id is in the hashset");
        return true;
    }

    ArrayList<ContentProviderOperation> operationList = new ArrayList<ContentProviderOperation>();

    // 遍历待删除的便签ID集合
    for (long id : ids) {
        if(id == Notes.ID_ROOT_FOLDER) {
            // 如果当前ID为系统文件夹根目录的ID，记录错误信息并跳过
            Log.e(TAG, "Don't delete system folder root");
            continue;
        }
        // 创建一个ContentProviderOperation.Builder用于构建删除指定ID的操作
        ContentProviderOperation.Builder builder = ContentProviderOperation.newDelete(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id));
        // 将操作添加到操作列表中
        operationList.add(builder.build());
    }
    try {
        // 应用操作列表中的所有操作来批量删除便签
        ContentProviderResult[] results = resolver.applyBatch(Notes.AUTHORITY, operationList);
        if (results == null || results.length == 0 || results[0] == null) {
            // 如果删除操作失败，记录错误信息并返回false
            Log.d(TAG, "delete notes failed, ids:" + ids.toString());
            return false;
        }
        // 删除操作成功完成，返回true
        return true;
    } catch (RemoteException e) {
        // 捕获RemoteException异常，记录错误信息
        Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
    } catch (OperationApplicationException e) {
        // 捕获OperationApplicationException异常，记录错误信息
        Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
    }
    // 出现异常情况，返回false
    return false;
}

/**
 * 将指定 id 的笔记移动到指定文件夹中
 *
 * @param resolver     ContentResolver 对象，用于访问应用程序数据
 * @param id           要移动的笔记的 ID
 * @param srcFolderId  源文件夹的 ID
 * @param desFolderId  目标文件夹的 ID
 */
public static void moveNoteToFoler(ContentResolver resolver, long id, long srcFolderId, long desFolderId) {
    // 创建包含要更新的内容的 ContentValues 对象
    ContentValues values = new ContentValues();
    values.put(NoteColumns.PARENT_ID, desFolderId); // 将笔记的父文件夹 ID 设置为目标文件夹的 ID
    values.put(NoteColumns.ORIGIN_PARENT_ID, srcFolderId); // 设置笔记的原始父文件夹 ID 为源文件夹的 ID
    values.put(NoteColumns.LOCAL_MODIFIED, 1); // 标记笔记已在本地修改
    // 使用 ContentResolver 执行更新操作
    resolver.update(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id), values, null, null);
}

/**
 * 批量将笔记移动到指定文件夹
 *
 * @param resolver   ContentResolver 对象，用于访问应用程序数据
 * @param ids        要移动的笔记的 ID 集合
 * @param folderId   目标文件夹的 ID
 * @return           操作是否成功的布尔值，true 表示成功，false 表示失败
 */
public static boolean batchMoveToFolder(ContentResolver resolver, HashSet<Long> ids, long folderId) {
    if (ids == null) {
        Log.d(TAG, "the ids is null");
        return true;
    }

    // 创建存储 ContentProviderOperation 的列表
    ArrayList<ContentProviderOperation> operationList = new ArrayList<ContentProviderOperation>();
    for (long id : ids) {
        // 创建一个更新操作的 Builder
        ContentProviderOperation.Builder builder = ContentProviderOperation.newUpdate(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id));
        builder.withValue(NoteColumns.PARENT_ID, folderId); // 设置笔记的父文件夹 ID 为目标文件夹的 ID
        builder.withValue(NoteColumns.LOCAL_MODIFIED, 1); // 标记笔记已在本地修改
        operationList.add(builder.build()); // 将操作加入列表
    }

    try {
        // 应用批量操作并获取结果
        ContentProviderResult[] results = resolver.applyBatch(Notes.AUTHORITY, operationList);
        if (results == null || results.length == 0 || results[0] == null) {
            Log.d(TAG, "delete notes failed, ids:" + ids.toString());
            return false;
        }
        return true;
    } catch (RemoteException e) {
        Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
    } catch (OperationApplicationException e) {
        Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
    }
    return false;
}
/**
 * 获取所有用户文件夹的数量，不包括系统文件夹 {@link Notes#TYPE_SYSTEM}
 *
 * @param resolver  ContentResolver 对象，用于访问应用程序数据
 * @return          用户文件夹的数量
 */
public static int getUserFolderCount(ContentResolver resolver) {
    // 查询数据库获取用户文件夹的数量
    Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI,
            new String[] { "COUNT(*)" },
            NoteColumns.TYPE + "=? AND " + NoteColumns.PARENT_ID + "<>?",
            new String[] { String.valueOf(Notes.TYPE_FOLDER), String.valueOf(Notes.ID_TRASH_FOLER)},
            null);

    int count = 0;
    if (cursor != null) {
        if (cursor.moveToFirst()) {
            try {
                count = cursor.getInt(0);
            } catch (IndexOutOfBoundsException e) {
                Log.e(TAG, "get folder count failed:" + e.toString());
            } finally {
                cursor.close();
            }
        }
    }
    return count;
}

/**
 * 判断笔记是否在笔记数据库中可见
 *
 * @param resolver  ContentResolver 对象，用于访问应用程序数据
 * @param noteId    笔记的 ID
 * @param type      笔记的类型
 * @return          笔记是否可见的布尔值，true 表示可见，false 表示不可见
 */
public static boolean visibleInNoteDatabase(ContentResolver resolver, long noteId, int type) {
    // 查询数据库判断笔记是否可见
    Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId),
            null,
            NoteColumns.TYPE + "=? AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER,
            new String[] { String.valueOf(type) },
            null);

    boolean exist = false;
    if (cursor != null) {
        if (cursor.getCount() > 0) {
            exist = true;
        }
        cursor.close();
    }
    return exist;
}

/**
 * 检查给定笔记 ID 对应的笔记是否存在于笔记数据库中
 *
 * @param resolver  ContentResolver 对象，用于访问应用程序数据
 * @param noteId    待查询的笔记 ID
 * @return          笔记是否存在于数据库中的布尔值，true 表示存在，false 表示不存在
 */
public static boolean existInNoteDatabase(ContentResolver resolver, long noteId) {
    // 使用ContentResolver对象进行查询
    Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId),
            null, null, null, null);

    boolean exist = false;
    // 检查结果集是否为空
    if (cursor != null) {
        if (cursor.getCount() > 0) {
            exist = true;
        }
        // 关闭数据库查询结果游标
        cursor.close();
    }
    return exist;
}

/**
 * 检查给定数据 ID 对应的数据是否存在于数据数据库中
 *
 * @param resolver  ContentResolver 对象，用于访问应用程序数据
 * @param dataId    待查询的数据 ID
 * @return          数据是否存在于数据库中的布尔值，true 表示存在，false 表示不存在
 */
public static boolean existInDataDatabase(ContentResolver resolver, long dataId) {
    // 使用ContentResolver对象进行查询
    Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_DATA_URI, dataId),
            null, null, null, null);

    boolean exist = false;
    // 检查结果集是否为空
    if (cursor != null) {
        if (cursor.getCount() > 0) {
            exist = true;
        }
        // 关闭数据库查询结果游标
        cursor.close();
    }
    return exist;
}

/**
 * 检查给定文件夹名称是否存在于笔记数据库中
 *
 * @param resolver  ContentResolver 对象，用于访问应用程序数据
 * @param name      待查询的文件夹名称
 * @return          文件夹名称是否存在于数据库中的布尔值，true 表示存在，false 表示不存在
 */
public static boolean checkVisibleFolderName(ContentResolver resolver, String name) {
    // 使用ContentResolver对象进行查询
    Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI, null,
            NoteColumns.TYPE + "=" + Notes.TYPE_FOLDER +
                    " AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER +
                    " AND " + NoteColumns.SNIPPET + "=?",
            new String[] { name }, null);
    boolean exist = false;
    // 检查结果集是否为空
    if(cursor != null) {
        if(cursor.getCount() > 0) {
            exist = true;
        }
        // 关闭数据库查询结果游标
        cursor.close();
    }
    return exist;
}

/**
 * 获取指定文件夹下的小部件属性集合
 *
 * @param resolver  ContentResolver 对象，用于访问应用程序数据
 * @param folderId  待查询的文件夹 ID
 * @return          包含小部件属性的 HashSet，如果查询结果为空则返回 null
 */
public static HashSet<AppWidgetAttribute> getFolderNoteWidget(ContentResolver resolver, long folderId) {
    // 使用ContentResolver对象进行查询
    Cursor c = resolver.query(Notes.CONTENT_NOTE_URI,
            new String[] {NoteColumns.WIDGET_ID, NoteColumns.WIDGET_TYPE},
            NoteColumns.PARENT_ID + "=?",
            new String[] {String.valueOf(folderId)},
            null);

    HashSet<AppWidgetAttribute> set = null;
    if (c != null) {
        if (c.moveToFirst()) {
            set = new HashSet<>();
            do {
                try {
                    AppWidgetAttribute widget = new AppWidgetAttribute();
                    widget.widgetId = c.getInt(0);
                    widget.widgetType = c.getInt(1);
                    set.add(widget);
                } catch (IndexOutOfBoundsException e) {
                    Log.e(TAG, e.toString());
                }
            } while (c.moveToNext());
        }
        c.close();
    }
    return set;
}

/**
 * 根据笔记 ID 获取对应的通话号码
 *
 * @param resolver  ContentResolver 对象，用于访问应用程序数据
 * @param noteId    待查询的笔记 ID
 * @return          笔记对应的通话号码，如果查询失败则返回空字符串
 */
public static String getCallNumberByNoteId(ContentResolver resolver, long noteId) {
    Cursor cursor = resolver.query(Notes.CONTENT_DATA_URI,
            new String[] {CallNote.PHONE_NUMBER},
            CallNote.NOTE_ID + "=? AND " + CallNote.MIME_TYPE + "=?",
            new String[] {String.valueOf(noteId), CallNote.CONTENT_ITEM_TYPE},
            null);

    if (cursor != null && cursor.moveToFirst()) {
        try {
            return cursor.getString(0);
        } catch (IndexOutOfBoundsException e) {
            Log.e(TAG, "Get call number fails " + e.toString());
        } finally {
            cursor.close();
        }
    }
    return "";
}

/**
 * 根据通话号码和通话日期获取对应的笔记 ID
 *
 * @param resolver      ContentResolver 对象，用于访问应用程序数据
 * @param phoneNumber   待查询的通话号码
 * @param callDate      通话日期
 * @return              笔记 ID，如果查询失败则返回 0
 */
/**
 * 根据通话号码和通话日期获取对应的笔记 ID
 *
 * @param resolver      ContentResolver 对象，用于访问应用程序数据
 * @param phoneNumber   待查询的通话号码
 * @param callDate      通话日期
 * @return              笔记 ID，如果查询失败则返回 0
 */
public static long getNoteIdByPhoneNumberAndCallDate(ContentResolver resolver, String phoneNumber, long callDate) {
    Cursor cursor = resolver.query(Notes.CONTENT_DATA_URI,
            new String[] {CallNote.NOTE_ID},
            CallNote.CALL_DATE + "=? AND " + CallNote.MIME_TYPE + "=? AND PHONE_NUMBERS_EQUAL(" +
                    CallNote.PHONE_NUMBER + ",?)",
            new String[] {String.valueOf(callDate), CallNote.CONTENT_ITEM_TYPE, phoneNumber},
            null);

    if (cursor != null) {
        if (cursor.moveToFirst()) {
            try {
                return cursor.getLong(0);
            } catch (IndexOutOfBoundsException e) {
                Log.e(TAG, "Get call note id fails " + e.toString());
            }
        }
        cursor.close();
    }
    return 0;
}

/**
 * 根据笔记 ID获取对应的摘要信息
 *
 * @param resolver  ContentResolver 对象，用于访问应用程序数据
 * @param noteId    待查询的笔记 ID
 * @return          笔记对应的摘要信息，如果查询失败则抛出 IllegalArgumentException
 */
public static String getSnippetById(ContentResolver resolver, long noteId) {
    Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI,
            new String [] { NoteColumns.SNIPPET },
            NoteColumns.ID + "=?",
            new String [] { String.valueOf(noteId)},
            null);

    if (cursor != null) {
        String snippet = "";
        if (cursor.moveToFirst()) {
            snippet = cursor.getString(0);
        }
        cursor.close();
        return snippet;
    }
    throw new IllegalArgumentException("Note is not found with id: " + noteId);
}

/**
 * 格式化摘要信息，只保留第一行内容并去除前后空格
 *
 * @param snippet   待格式化的摘要信息
 * @return          格式化后的摘要信息
 */
public static String getFormattedSnippet(String snippet) {
    if (snippet != null) {
        snippet = snippet.trim();
        int index = snippet.indexOf('\n');
        if (index != -1) {
            snippet = snippet.substring(0, index);
        }
    }
    return snippet;
}
}
